[CCode (cheader_filename = "valaccodeassignment.h")]
namespace Vala {
	public class CCodeAssignment : Vala.CCodeExpression {
		public construct  (Vala.CCodeExpression l, Vala.CCodeExpression r, Vala.CCodeAssignmentOperator op = CCodeAssignmentOperator.SIMPLE);
		public Vala.CCodeExpression left { get; construct; }
		public weak Vala.CCodeAssignmentOperator operator { get; set; }
		public Vala.CCodeExpression right { get; construct; }
	}
}
[CCode (cheader_filename = "valaccodeassignment.h")]
namespace Vala {
	public enum CCodeAssignmentOperator {
		SIMPLE,
		BITWISE_OR,
		BITWISE_AND,
		BITWISE_XOR,
		ADD,
		SUB,
		MUL,
		DIV,
		PERCENT,
		SHIFT_LEFT,
		SHIFT_RIGHT,
	}
}
[CCode (cheader_filename = "valaccodebinaryexpression.h")]
namespace Vala {
	public class CCodeBinaryExpression : Vala.CCodeExpression {
		public construct  (Vala.CCodeBinaryOperator op, Vala.CCodeExpression l, Vala.CCodeExpression r);
		public weak Vala.CCodeBinaryOperator operator { get; set; }
		public Vala.CCodeExpression left { get; set construct; }
		public Vala.CCodeExpression right { get; set construct; }
	}
}
[CCode (cheader_filename = "valaccodebinaryexpression.h")]
namespace Vala {
	public enum CCodeBinaryOperator {
		PLUS,
		MINUS,
		MUL,
		DIV,
		MOD,
		SHIFT_LEFT,
		SHIFT_RIGHT,
		LESS_THAN,
		GREATER_THAN,
		LESS_THAN_OR_EQUAL,
		GREATER_THAN_OR_EQUAL,
		EQUALITY,
		INEQUALITY,
		BITWISE_AND,
		BITWISE_OR,
		BITWISE_XOR,
		AND,
		OR,
	}
}
[CCode (cheader_filename = "valaccodeblock.h")]
namespace Vala {
	public class CCodeBlock : Vala.CCodeStatement {
		public void prepend_statement (Vala.CCodeNode statement);
		public void add_statement (Vala.CCodeNode statement);
		public weak bool suppress_newline { get; set; }
	}
}
[CCode (cheader_filename = "valaccodebreakstatement.h")]
namespace Vala {
	public class CCodeBreakStatement : Vala.CCodeStatement {
	}
}
[CCode (cheader_filename = "valaccodecasestatement.h")]
namespace Vala {
	public class CCodeCaseStatement : Vala.CCodeStatement {
		public construct  (Vala.CCodeExpression expr);
		public void add_statement (Vala.CCodeStatement stmt);
		public Vala.CCodeExpression expression { get; set construct; }
	}
}
[CCode (cheader_filename = "valaccodecastexpression.h")]
namespace Vala {
	public class CCodeCastExpression : Vala.CCodeExpression {
		public construct  (Vala.CCodeExpression expr, string type);
		public Vala.CCodeExpression inner { get; set construct; }
		public string type_name { get; set construct; }
	}
}
[CCode (cheader_filename = "valaccodecommaexpression.h")]
namespace Vala {
	public class CCodeCommaExpression : Vala.CCodeExpression {
		public void append_expression (Vala.CCodeExpression expr);
	}
}
[CCode (cheader_filename = "valaccodecomment.h")]
namespace Vala {
	public class CCodeComment : Vala.CCodeNode {
		public construct  (string _text);
		public string text { get; set construct; }
	}
}
[CCode (cheader_filename = "valaccodeconditionalexpression.h")]
namespace Vala {
	public class CCodeConditionalExpression : Vala.CCodeExpression {
		public construct  (Vala.CCodeExpression cond, Vala.CCodeExpression true_expr, Vala.CCodeExpression false_expr);
		public Vala.CCodeExpression condition { get; set construct; }
		public Vala.CCodeExpression true_expression { get; set construct; }
		public Vala.CCodeExpression false_expression { get; set construct; }
	}
}
[CCode (cheader_filename = "valaccodeconstant.h")]
namespace Vala {
	public class CCodeConstant : Vala.CCodeExpression {
		public construct  (string _name);
		public string name { get; set construct; }
	}
}
[CCode (cheader_filename = "valaccodecontinuestatement.h")]
namespace Vala {
	public class CCodeContinueStatement : Vala.CCodeStatement {
	}
}
[CCode (cheader_filename = "valaccodedeclaration.h")]
namespace Vala {
	public class CCodeDeclaration : Vala.CCodeStatement {
		public construct  (string _type_name);
		public void add_declarator (Vala.CCodeDeclarator decl);
		public string type_name { get; set construct; }
		public weak Vala.CCodeModifiers modifiers { get; set; }
	}
}
[CCode (cheader_filename = "valaccodedeclarator.h")]
namespace Vala {
	public abstract class CCodeDeclarator : Vala.CCodeNode {
	}
}
[CCode (cheader_filename = "valaccodeemptystatement.h")]
namespace Vala {
	public class CCodeEmptyStatement : Vala.CCodeStatement {
	}
}
[CCode (cheader_filename = "valaccodeenum.h")]
namespace Vala {
	public class CCodeEnum : Vala.CCodeNode {
		public construct  (string n = null);
		public void add_value (string name, string value = null);
		public string name { get; set; }
	}
}
[CCode (cheader_filename = "valaccodeexpression.h")]
namespace Vala {
	public abstract class CCodeExpression : Vala.CCodeNode {
	}
}
[CCode (cheader_filename = "valaccodeexpressionstatement.h")]
namespace Vala {
	public class CCodeExpressionStatement : Vala.CCodeStatement {
		public construct  (Vala.CCodeExpression expr);
		public Vala.CCodeExpression expression { get; set construct; }
	}
}
[CCode (cheader_filename = "valaccodeformalparameter.h")]
namespace Vala {
	public class CCodeFormalParameter : Vala.CCodeNode {
		public construct  (string n, string type);
		public string name { get; set construct; }
		public string type_name { get; set construct; }
	}
}
[CCode (cheader_filename = "valaccodeforstatement.h")]
namespace Vala {
	public class CCodeForStatement : Vala.CCodeStatement {
		public construct  (Vala.CCodeExpression cond, Vala.CCodeStatement stmt = null);
		public void add_initializer (Vala.CCodeExpression expr);
		public void add_iterator (Vala.CCodeExpression expr);
		public Vala.CCodeExpression condition { get; set construct; }
		public Vala.CCodeStatement body { get; set; }
	}
}
[CCode (cheader_filename = "valaccodefragment.h")]
namespace Vala {
	public class CCodeFragment : Vala.CCodeNode {
		public void append (Vala.CCodeNode node);
		public ref GLib.List get_children ();
	}
}
[CCode (cheader_filename = "valaccodefunction.h")]
namespace Vala {
	public class CCodeFunction : Vala.CCodeNode {
		public construct  (string _name, string _return_type);
		public void add_parameter (Vala.CCodeFormalParameter param);
		public ref Vala.CCodeFunction copy ();
		public string name { get; set construct; }
		public weak Vala.CCodeModifiers modifiers { get; set; }
		public string return_type { get; set construct; }
		public Vala.CCodeBlock block { get; set; }
	}
}
[CCode (cheader_filename = "valaccodefunctioncall.h")]
namespace Vala {
	public class CCodeFunctionCall : Vala.CCodeExpression {
		public construct  (Vala.CCodeExpression _call = null);
		public void add_argument (Vala.CCodeExpression expr);
		public Vala.CCodeExpression call { get; set; }
	}
}
[CCode (cheader_filename = "valaccodefunctiondeclarator.h")]
namespace Vala {
	public class CCodeFunctionDeclarator : Vala.CCodeDeclarator {
		public construct  (string n);
		public void add_parameter (Vala.CCodeFormalParameter param);
		public string name { get; set construct; }
	}
}
[CCode (cheader_filename = "valaccodeidentifier.h")]
namespace Vala {
	public class CCodeIdentifier : Vala.CCodeExpression {
		public construct  (string _name);
		public string name { get; set construct; }
	}
}
[CCode (cheader_filename = "valaccodeifstatement.h")]
namespace Vala {
	public class CCodeIfStatement : Vala.CCodeStatement {
		public construct  (Vala.CCodeExpression cond, Vala.CCodeStatement true_stmt, Vala.CCodeStatement false_stmt = null);
		public Vala.CCodeExpression condition { get; set construct; }
		public Vala.CCodeStatement true_statement { get; set construct; }
		public Vala.CCodeStatement false_statement { get; set construct; }
		public weak bool else_if { get; set; }
	}
}
[CCode (cheader_filename = "valaccodeincludedirective.h")]
namespace Vala {
	public class CCodeIncludeDirective : Vala.CCodeNode {
		public construct  (string _filename, bool _local = false);
		public string filename { get; set construct; }
		public weak bool local { get; set; }
	}
}
[CCode (cheader_filename = "valaccodeinitializerlist.h")]
namespace Vala {
	public class CCodeInitializerList : Vala.CCodeExpression {
		public void append (Vala.CCodeExpression expr);
	}
}
[CCode (cheader_filename = "valaccodelinedirective.h")]
namespace Vala {
	public class CCodeLineDirective : Vala.CCodeNode {
		public construct  (string _filename, int _line);
		public string filename { get; set construct; }
		public weak int line { get; set; }
	}
}
[CCode (cheader_filename = "valaccodemacroreplacement.h")]
namespace Vala {
	public class CCodeMacroReplacement : Vala.CCodeNode {
		public construct  (string n, string replace);
		public string name { get; set construct; }
		public string replacement { get; set construct; }
	}
}
[CCode (cheader_filename = "valaccodememberaccess.h")]
namespace Vala {
	public class CCodeMemberAccess : Vala.CCodeExpression {
		public construct  (Vala.CCodeExpression container, string member);
		public construct  pointer (Vala.CCodeExpression container, string member);
		public Vala.CCodeExpression inner { get; set construct; }
		public string member_name { get; set construct; }
		public weak bool is_pointer { get; set; }
	}
}
[CCode (cheader_filename = "valaccodemodifiers.h")]
namespace Vala {
	public enum CCodeModifiers {
		NONE,
		STATIC,
	}
}
[CCode (cheader_filename = "valaccodenewline.h")]
namespace Vala {
	public class CCodeNewline : Vala.CCodeNode {
	}
}
[CCode (cheader_filename = "valaccodenode.h")]
namespace Vala {
	public abstract class CCodeNode {
		public abstract void write (Vala.CCodeWriter writer);
		public Vala.CCodeLineDirective line { get; set; }
	}
}
[CCode (cheader_filename = "valaccodeoncesection.h")]
namespace Vala {
	public class CCodeOnceSection : Vala.CCodeFragment {
		public construct  (string def);
		public string define { get; set construct; }
	}
}
[CCode (cheader_filename = "valaccodeparenthesizedexpression.h")]
namespace Vala {
	public class CCodeParenthesizedExpression : Vala.CCodeExpression {
		public construct  (Vala.CCodeExpression expr);
		public Vala.CCodeExpression inner { get; set construct; }
	}
}
[CCode (cheader_filename = "valaccodereturnstatement.h")]
namespace Vala {
	public class CCodeReturnStatement : Vala.CCodeStatement {
		public construct  (Vala.CCodeExpression expr = null);
		public Vala.CCodeExpression return_expression { get; set; }
	}
}
[CCode (cheader_filename = "valaccodestatement.h")]
namespace Vala {
	public abstract class CCodeStatement : Vala.CCodeNode {
	}
}
[CCode (cheader_filename = "valaccodestruct.h")]
namespace Vala {
	public class CCodeStruct : Vala.CCodeNode {
		public construct  (string n);
		public void add_declaration (Vala.CCodeDeclaration decl);
		public void add_field (string type_name, string name);
		public string name { get; set construct; }
	}
}
[CCode (cheader_filename = "valaccodeswitchstatement.h")]
namespace Vala {
	public class CCodeSwitchStatement : Vala.CCodeStatement {
		public construct  (Vala.CCodeExpression expr);
		public void add_case (Vala.CCodeCaseStatement case_stmt);
		public Vala.CCodeExpression expression { get; set construct; }
	}
}
[CCode (cheader_filename = "valaccodetypedefinition.h")]
namespace Vala {
	public class CCodeTypeDefinition : Vala.CCodeNode {
		public construct  (string type, Vala.CCodeDeclarator decl);
		public string type_name { get; set; }
		public Vala.CCodeDeclarator declarator { get; set; }
	}
}
[CCode (cheader_filename = "valaccodeunaryexpression.h")]
namespace Vala {
	public class CCodeUnaryExpression : Vala.CCodeExpression {
		public construct  (Vala.CCodeUnaryOperator op, Vala.CCodeExpression expr);
		public weak Vala.CCodeUnaryOperator operator { get; set; }
		public Vala.CCodeExpression inner { get; set construct; }
	}
}
[CCode (cheader_filename = "valaccodeunaryexpression.h")]
namespace Vala {
	public enum CCodeUnaryOperator {
		PLUS,
		MINUS,
		LOGICAL_NEGATION,
		BITWISE_COMPLEMENT,
		ADDRESS_OF,
		PREFIX_INCREMENT,
		PREFIX_DECREMENT,
		POSTFIX_INCREMENT,
		POSTFIX_DECREMENT,
	}
}
[CCode (cheader_filename = "valaccodevariabledeclarator.h")]
namespace Vala {
	public class CCodeVariableDeclarator : Vala.CCodeDeclarator {
		public construct  (string _name);
		public construct  with_initializer (string _name, Vala.CCodeExpression init);
		public string name { get; set construct; }
		public Vala.CCodeExpression initializer { get; set; }
	}
}
[CCode (cheader_filename = "valaccodewhilestatement.h")]
namespace Vala {
	public class CCodeWhileStatement : Vala.CCodeStatement {
		public construct  (Vala.CCodeExpression cond, Vala.CCodeStatement stmt = null);
		public Vala.CCodeExpression condition { get; set construct; }
		public Vala.CCodeStatement body { get; set; }
	}
}
[CCode (cheader_filename = "valaccodewriter.h")]
namespace Vala {
	public class CCodeWriter {
		public construct  (string _filename);
		public void close ();
		public void write_indent ();
		public void write_string (string s);
		public void write_newline ();
		public void write_begin_block ();
		public void write_end_block ();
		public void write_comment (string text);
		public string filename { get; construct; }
		public weak bool bol { get; }
	}
}
[CCode (cheader_filename = "valaccodeelementaccess.h")]
namespace Vala {
	public class CCodeElementAccess : Vala.CCodeExpression {
		public construct  (Vala.CCodeExpression cont, Vala.CCodeExpression i);
		public Vala.CCodeExpression container { get; set construct; }
		public Vala.CCodeExpression index { get; set construct; }
	}
}
